package edu.northwestern.dasu.drools;

import java.util.LinkedList;

import edu.northwestern.dasu.Main;
import edu.northwestern.dasu.stats.DownloadStatsDynamic;

import org.gudy.azureus2.plugins.download.DownloadManager;

/* 
 * For an member to be visible to Jess (as part of the fact)  
 *  it must have it's own public setter and getter functions
 */
public class FactMeasurementDsd extends FactMeasurement<DownloadStatsDynamic> {

		private long timeRecorded;
		private long downloadId;
		private int numPeers;
		private float availability;
		private int completed;
		private int downloadRate;
		private int uploadRate;
		private int numKnownNonSeeds;
		private int numKnownSeeds;
		private int totalNumKnownNonSeeds=-1;
		private int totalNumKnownSeeds=-1;
		private int state;
		private int priority;
		private long downloaded;
		private long uploaded;
		private String downloadName;
		private int connectedSeeds;
		private int connectedLeechers;
		private int numPendingPeers;

		private int numRst;  /*in the past 5 minutes (set by FactMeasurementDsd)*/ 
		private boolean justCompleted; /*true if dld completed in the past 3 minutes*/
		private float averageUploadNC=-1;
		private float averageNumPeersNC=-1;
		private float averageConnectedSeedsNC=-1;
		private float averageConnectedLeechersNC=-1;

        private Float averageDownload=0f;
        private Float averageUpload=0f;
        private Float averageNumPeers=0f;
        private Float averageConnectedSeeds=0f;
        private Float averageConnectedLeechers=0f;
        private Float stdevDownload=0f;
        private Float stdevUpload=0f;
        private Float stdevNumPeers=0f;
        private Float stdevConnectedSeeds=0f;
        private Float stdevConnectedLeechers=0f;
        
        
		public FactMeasurementDsd() {
			
		}
		
		public FactMeasurementDsd(DownloadStatsDynamic dsd) {
			
			this.timeRecorded = dsd.timeRecorded;
			this.downloadId = dsd.downloadId;
			this.numPeers = dsd.numPeers;
			this.availability = dsd.availability;
			this.completed = dsd.completed;
			this.downloadRate = dsd.downloadRate;
			this.uploadRate = dsd.uploadRate;
			this.numKnownNonSeeds = dsd.numKnownNonSeeds;
			this.numKnownSeeds = dsd.numKnownSeeds;
			this.totalNumKnownNonSeeds = dsd.totalNumKnownNonSeeds;
			this.totalNumKnownSeeds = dsd.totalNumKnownSeeds; 
			this.state = dsd.state;
			this.priority = dsd.priority;
			this.downloaded = dsd.downloaded;
			this.uploaded = dsd.uploaded;
			this.justCompleted = false;
			this.numRst = 0;
			this.downloadName = dsd.downloadName;
			this.connectedSeeds = dsd.connectedSeeds;
			this.connectedLeechers = dsd.connectedLeechers;
			this.numPendingPeers = dsd.numPendingPeers;
			
			addEntry(dsd);
			
		}
		
		@Override
		public void updateAll(DownloadStatsDynamic dsd) {
			
			this.timeRecorded = (dsd.timeRecorded);
			this.downloadId = (dsd.downloadId);
			this.numPeers = (dsd.numPeers);
			this.availability = (dsd.availability);
			this.completed = (dsd.completed);
			this.downloadRate = (dsd.downloadRate);
			this.uploadRate = (dsd.uploadRate);
			this.numKnownNonSeeds = (dsd.numKnownNonSeeds);
			this.numKnownSeeds = (dsd.numKnownSeeds);
			this.totalNumKnownNonSeeds = (dsd.totalNumKnownNonSeeds);
			this.totalNumKnownSeeds = (dsd.totalNumKnownSeeds); 
			this.state = (dsd.state);
			this.priority = (dsd.priority);
			this.downloaded = (dsd.downloaded);
			this.uploaded = (dsd.uploaded);
			this.connectedSeeds = (dsd.connectedSeeds);
			this.connectedLeechers = (dsd.connectedLeechers);
			this.numPendingPeers = (dsd.numPendingPeers);
			
			updateDynamic();
			
			if (DEBUG) {

				System.out.println("\nFactMeasurementDsd");
				for (int i = 0; i < entryList.size(); i++ ) {
					System.out.println(entryList.get(i).timeRecorded + " numPeers " +
							entryList.get(i).numPeers + " downloadRate " + 
							entryList.get(i).downloadRate + " uploadRate " + 
							entryList.get(i).uploadRate);
				}
			

				System.out.println("avgDownloadRate: " + averageDownload +
						" avgUploadRate: " + averageUpload +
						" avgUploadRateNC: " + averageUploadNC +
						" completed: " + completed + 
						" justCompleted " + justCompleted);
				
				System.out.println("avgNumPeers: " + averageNumPeers +
						" avgNumPeersNC: " + averageNumPeersNC +
						" avgConnectedSeeds: " + averageConnectedSeeds +
						" avgConnectedSeedsNC: " + averageConnectedSeedsNC +
						" avgConnectedLeechers: " + averageConnectedLeechers +
						" avgConnectedLeechersNC: " + averageConnectedLeechersNC);
				
				System.out.println();
			}
			
		}
		
		public long getTimeRecorded() {
			return timeRecorded;
		}
		
		public long getDownloadId() {
			return downloadId;
		}

		public int getNumPeers() {
			return numPeers;
		}
		
		public Float getAvailability() {
			return availability;
		}
		
		public int getCompleted() {
			return completed;
		}
		
		public int getDownloadRate() {
			return downloadRate;
		}
		
		public int getUploadRate() {
			return uploadRate;
		}
		
		public int getNumKnownNonSeeds() {
			return numKnownNonSeeds;
		}
		
		public int getNumKnownSeeds() {
			return numKnownSeeds;
		}
		
		public int getTotalNumKnownNonSeeds() {
			return totalNumKnownNonSeeds;
		}
		
		public int getTotalNumKnownSeeds() {
			return totalNumKnownSeeds;
		}
		
		public int getState() {
			return state;
		}
		
		public int getPriority() {
			return priority;
		}
		public long getDownloaded() {
			return downloaded;
		}
		
		public long getUploaded() {
			return uploaded;
		}
		
		public Float getAverageDownload() {
			return averageDownload;
		}
        
		public Float getAverageUpload() {
			return averageUpload;
		}
        
		public Float getAverageNumPeers() {
			return averageNumPeers;
		}
		
        public Float getStdevDownload(){
        	return stdevDownload;
        }
        
        public Float getStdevUpload() {
        	return stdevUpload;
        }
        
        public Float getStdevNumPeers() {
        	return stdevNumPeers;
        }
        
        public Float getStdevConnectedSeeds() {
        	return stdevConnectedSeeds;
        }
        
        public Float getStdevConnectedLeechers() {
        	return stdevConnectedLeechers;
        }
        
		public boolean isJustCompleted() {
			return justCompleted;
		}

		public Float getAverageUploadNC() {
			return averageUploadNC;
		}
		
		public Float getAverageNumPeersNC() {
			return averageNumPeersNC;
		}

		public Float getAverageConnectedSeedsNC() {
			return averageConnectedSeedsNC;
		}
		
		public Float getAverageConnectedLeechersNC() {
			return averageConnectedLeechersNC;
		}
		
		public Float getAverageConnectedSeeds() {
			return averageConnectedSeeds;
		}
		
		public Float getAverageConnectedLeechers() {
			return averageConnectedLeechers;
		}
		
		public int getNumRst() {
			return numRst;
		}
		
		public int getConnectedSeeds() {
			return connectedSeeds;
		}
		
		public int getConnectedLeechers() {
			return connectedLeechers;
		}
		
		public int getNumPendingPeers() {
			return numPendingPeers;
		}
		
		public String getDownloadName() {
			return downloadName;
		}
				

		public void setTimeRecorded(final Long timeRecorded) {
			Long temp = this.timeRecorded;
			this.timeRecorded = timeRecorded;
	        pcs.firePropertyChange("timeRecorded", new Long(temp), new Long(timeRecorded));
		}
		
		public void setDownloadId(final Long downloadId) {
			Long temp = this.downloadId;
			this.downloadId = downloadId;
	        pcs.firePropertyChange("downloadId", new Long(temp), new Long(downloadId));
		}

		public void setNumPeers(final Integer numPeers) {
			Integer temp = this.numPeers;
			this.numPeers = numPeers;
	        pcs.firePropertyChange("numPeers", new Integer(temp), new Integer(numPeers));
		}
		
		public void setAvailability(final Float availability) {
			Float temp = this.availability;
			this.availability = availability;
	        pcs.firePropertyChange("availability", new Float(temp), new Float(availability));
		}

		public void setCompleted(final Integer completed) {
			Integer temp = this.completed;
			this.completed = completed;
	        pcs.firePropertyChange("completed", new Integer(temp), new Integer(completed));
		}
				
		public void setDownloadRate(final Integer downloadRate) {
			Integer temp = this.downloadRate;
			this.downloadRate = downloadRate;
	        pcs.firePropertyChange("downloadRate", new Integer(temp), new Integer(downloadRate));			
		}
		
		public void setUploadRate(final Integer uploadRate) {
			Integer temp = this.uploadRate;
			this.uploadRate = uploadRate;
	        pcs.firePropertyChange("uploadRate", new Integer(temp), new Integer(uploadRate));			
		}
		
		public void setNumKnownNonSeeds(final Integer numKnownNonSeeds) {
			Integer temp = this.numKnownNonSeeds;
			this.numKnownNonSeeds = numKnownNonSeeds;
	        pcs.firePropertyChange("numKnownNonSeeds", new Integer(temp), new Integer(numKnownNonSeeds));			
		}
		
		public void setNumKnownSeeds(final Integer numKnownSeeds) {
			Integer temp = this.numKnownSeeds;
			this.numKnownSeeds = numKnownSeeds;
	        pcs.firePropertyChange("numKnownSeeds", new Integer(temp), new Integer(numKnownSeeds));			
		}
		
		public void setTotalNumKnownNonSeeds(final Integer totalNumKnownNonSeeds) {
			Integer temp = this.totalNumKnownNonSeeds;
			this.totalNumKnownNonSeeds = totalNumKnownNonSeeds;
	        pcs.firePropertyChange("totalNumKnownNonSeeds", new Integer(temp), new Integer(totalNumKnownNonSeeds));			
		}
		
		public void setTotalNumKnownSeeds(final Integer totalNumKnownSeeds) {
			Integer temp = this.totalNumKnownSeeds;
			this.totalNumKnownSeeds = totalNumKnownSeeds;
	        pcs.firePropertyChange("totalNumKnownSeeds", new Integer(temp), new Integer(totalNumKnownSeeds));			
		}
		
		public void setState(final Integer state) {
			Integer temp = this.state;
			this.state = state;
	        pcs.firePropertyChange("state", new Integer(temp), new Integer(state));			
		}
		
		public void setPriority(final Integer priority) {
			Integer temp = this.priority;
			this.priority = priority;
	        pcs.firePropertyChange("priority", new Integer(temp), new Integer(priority));			
		}
		
		public void setDownloaded(final Long downloaded) {
			Long temp = this.downloaded;
			this.downloaded = downloaded;
	        pcs.firePropertyChange("downloaded", new Long(temp), new Long(downloaded));			
		}
		
		public void setUploaded(final Long uploaded) {
			Long temp = this.uploaded;
			this.uploaded = uploaded;
	        pcs.firePropertyChange("uploaded", new Long(temp), new Long(uploaded));			
		}
		
		public void setAverageDownload(final float averageDownload) {
			Float temp = this.averageDownload;
			this.averageDownload = averageDownload;
	        pcs.firePropertyChange("averageDownload", new Float(temp), new Float(averageDownload));			
		}
        
		public void setAverageUpload(final float averageUpload) {
			Float temp = this.averageUpload;
			this.averageUpload = averageUpload;
	        pcs.firePropertyChange("averageUpload", new Float(temp), new Float(averageUpload));			
		}
        
		public void setAverageNumPeers(final float averageNumPeers) {
			Float temp = this.averageNumPeers;
			this.averageNumPeers = averageNumPeers;
	        pcs.firePropertyChange("averageNumPeers", new Float(temp), new Float(averageNumPeers));			
		}
		
		public void setAverageConnectedSeeds(final float averageConnectedSeeds) {
			Float temp = this.averageConnectedSeeds;
			this.averageConnectedSeeds = averageConnectedSeeds;
	        pcs.firePropertyChange("averageConnectedSeeds", new Float(temp), new Float(averageConnectedSeeds));			
		}

		public void setAverageConnectedLeechers(final float averageConnectedLeechers) {
			Float temp = this.averageConnectedLeechers;
			this.averageConnectedLeechers = averageConnectedLeechers;
	        pcs.firePropertyChange("averageConnectedLeechers", new Float(temp), new Float(averageConnectedLeechers));			
		}
		
        public void setStdevDownload(final float stdevDownload){
			Float temp = this.stdevDownload;
			this.stdevDownload = stdevDownload;
	        pcs.firePropertyChange("stdevDownload", new Float(temp), new Float(stdevDownload));			
        }
        
        public void setStdevUpload(final float stdevUpload) {
			Float temp = this.stdevUpload;
			this.stdevUpload = stdevUpload;
	        pcs.firePropertyChange("stdevUpload", new Float(temp), new Float(stdevUpload));			
        }
        
        public void setStdevNumPeers(final float stdevNumPeers) {
			Float temp = this.stdevNumPeers;
			this.stdevNumPeers = stdevNumPeers;
	        pcs.firePropertyChange("stdevNumPeers", new Float(temp), new Float(stdevNumPeers));			
        }
        
        public void setStdevConnectedSeeds(final float stdevConnectedSeeds) {
			Float temp = this.stdevConnectedSeeds;
			this.stdevConnectedSeeds = stdevConnectedSeeds;
	        pcs.firePropertyChange("stdevConnectedSeeds", new Float(temp), new Float(stdevConnectedSeeds));			
        }
        
        public void setStdevConnectedLeechers(final float stdevConnectedLeechers) {
			Float temp = this.stdevConnectedLeechers;
			this.stdevConnectedLeechers = stdevConnectedLeechers;
	        pcs.firePropertyChange("stdevConnectedLeechers", new Float(temp), new Float(stdevConnectedLeechers));			
        }
        
		public void setJustCompleted(boolean justCompleted) {
			boolean temp = this.justCompleted;
			this.justCompleted = justCompleted;
	        pcs.firePropertyChange("justCompleted", new Boolean(temp), new Boolean(justCompleted));	
		}

		public void setAverageUploadNC(final float averageUploadNC) {
			Float temp = this.averageUploadNC;
			this.averageUploadNC = averageUploadNC;
	        pcs.firePropertyChange("averageUploadNC", new Float(temp), new Float(averageUploadNC));			
		}
		
		public void setAverageNumPeersNC(final float averageNumPeersNC) {
			Float temp = this.averageNumPeersNC;
			this.averageNumPeersNC = averageNumPeersNC;
	        pcs.firePropertyChange("averageNumPeersNC", new Float(temp), new Float(averageNumPeersNC));			
		}	

		public void setAverageConnectedSeedsNC(final float averageConnectedSeedsNC) {
			Float temp = this.averageConnectedSeedsNC;
			this.averageConnectedSeedsNC = averageConnectedSeedsNC;
	        pcs.firePropertyChange("averageConnectedSeedsNC", new Float(temp), new Float(averageConnectedSeedsNC));			
		}	

		public void setAverageConnectedLeechersNC(final float averageConnectedLeechersNC) {
			Float temp = this.averageConnectedLeechersNC;
			this.averageConnectedLeechersNC = averageConnectedLeechersNC;
	        pcs.firePropertyChange("averageConnectedLeechersNC", new Float(temp), new Float(averageConnectedLeechersNC));			
		}	


		public void setNumRst(final Integer numRst) {
			Integer temp = this.numRst;
			this.numRst = numRst;
	        pcs.firePropertyChange("numRst", new Integer(temp), new Integer(numRst));			
		}
	
		public void setConnectedSeeds(final Integer connectedSeeds) {
			Integer temp = this.connectedSeeds;
			this.connectedSeeds = connectedSeeds;
	        pcs.firePropertyChange("connectedSeeds", new Integer(temp), new Integer(connectedSeeds));			
		}

		public void setNumPendingPeers(final Integer numPendingPeers) {
			Integer temp = this.numPendingPeers;
			this.numPendingPeers = numPendingPeers;
	        pcs.firePropertyChange("numPendingPeers", new Integer(temp), new Integer(numPendingPeers));			
		}
		
		public void setConnectedLeechers(final Integer connectedLeechers) {
			Integer temp = this.connectedLeechers;
			this.connectedLeechers = connectedLeechers;
	        pcs.firePropertyChange("connectedLeechers", new Integer(temp), new Integer(connectedLeechers));			
		}
		
        public void updateDynamic() {
        	
        	int size = entryList.size();
        	int logSize = entryLog.size();
        	
        	if (this.justCompleted == true) {
        		for (int i=logSize-1; i > 0; i--) {
        			if ( entryLog.get(i).completed < 1000
        					&& (logSize-i+1) * interval / 60 <= 5 ) {
        				break;
        			}
        			
        			if ((logSize-i+1) * interval / 60 > 5 )
        				this.justCompleted = false;
        				//setJustCompleted(false);
        		}
        	}
        		
        	if (this.completed == 1000 && logSize > 1 &&   
        			entryLog.get(logSize-2).completed < 1000) {
        		this.justCompleted=true;
        		this.averageUploadNC = getAverageUpload();
        		this.averageNumPeersNC = getAverageNumPeers();
        		this.averageConnectedSeedsNC = getAverageConnectedSeeds();
        		this.averageConnectedLeechersNC = getAverageConnectedLeechers();
        		
        		//setJustCompleted(true);
        		//setAverageUploadNC(getAverageUpload());

        	}
        		
        	int sumDownload = 0;
        	int sumUpload = 0;
        	int sumNumPeers = 0;
        	int sumConnectedSeeds = 0;
        	int sumConnectedLeechers = 0;
        	for (int i=0; i < size; i++) {
        		
        		DownloadStatsDynamic dsd = (DownloadStatsDynamic) entryList.get(i);
        		sumDownload += dsd.downloadRate;
        		sumUpload += dsd.uploadRate;
        		sumNumPeers += dsd.numPeers;
        		sumConnectedSeeds += dsd.connectedSeeds;
        		sumConnectedLeechers += dsd.connectedLeechers;
        	}
        
        	float averageDownload = ((float) sumDownload / (float) size);
        	float averageUpload = ((float) sumUpload / (float) size);
        	float averageNumPeers = ((float) sumNumPeers / (float) size);
        	float averageConnectedSeeds = ((float) sumConnectedSeeds / (float) size);
        	float averageConnectedLeechers = ((float) sumConnectedLeechers / (float) size);
        	
            float sdqDevSumUpload = 0;
            float sdqDevSumDownload = 0;
            float sdqDevSumNumPeers = 0;
            float sdqDevSumConnectedSeeds = 0;
            float sdqDevSumConnectedLeechers = 0;
        	
        	for (int i=0; i < size; i++) {
        		
        		DownloadStatsDynamic dsd = (DownloadStatsDynamic) entryList.get(i);
        		sdqDevSumUpload += Math.pow( (averageUpload - dsd.uploadRate), 2);
        		sdqDevSumDownload += Math.pow( (averageDownload - dsd.downloadRate), 2);
        		sdqDevSumNumPeers += Math.pow( (averageNumPeers - dsd.numPeers), 2);
        		sdqDevSumConnectedSeeds += Math.pow( (averageConnectedSeeds - dsd.connectedSeeds), 2);
        		sdqDevSumConnectedLeechers += Math.pow( (averageConnectedLeechers - dsd.connectedLeechers), 2);

        	}        	
        	
//          setStdevUpload( (float) Math.sqrt(sdqDevSumUpload / size ));
//          setStdevDownload( (float) Math.sqrt(sdqDevSumDownload / size) );
//          setStdevNumPeers( (float) Math.sqrt(sdqDevSumNumPeers / size) );
//        	setAverageDownload(averageDownload);
//        	setAverageUpload(averageUpload);
//        	setAverageNumPeers(averageNumPeers);
        	
            this.stdevUpload = ( (float) Math.sqrt(sdqDevSumUpload / size ));
            this.stdevDownload = ( (float) Math.sqrt(sdqDevSumDownload / size) );
            this.stdevNumPeers = ( (float) Math.sqrt(sdqDevSumNumPeers / size) );
            this.stdevConnectedSeeds = ( (float) Math.sqrt(sdqDevSumConnectedSeeds / size) );
            this.stdevConnectedLeechers = ( (float) Math.sqrt(sdqDevSumConnectedLeechers / size) );
            
        	this.averageDownload = averageDownload;
        	this.averageUpload = averageUpload;
        	this.averageNumPeers = averageNumPeers;
        	this.averageConnectedSeeds = averageConnectedSeeds;
        	this.averageConnectedLeechers = averageConnectedLeechers;

//        	setNumRst(entryLog.get(entryLog.size()-1).numRst);
        	this.numRst = (entryLog.get(entryLog.size()-1).numRst);
        }
        
}
