package edu.northwestern.dasu.drools;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.HashSet;

import edu.northwestern.dasu.stats.DynamicLocalPeerStat;

/* 
 * For an member to be visible to Jess (as part of the fact)  
 *  it must have it's own public setter and getter functions
 */
public class FactMeasurementLpsd extends FactMeasurement<DynamicLocalPeerStat> {

		private long timeRecorded=-1;
		private int uploadRate=-1;
		private int downloadRate=-1;
		private int maxUploadRate=-1;
		private int maxDownloadRate=-1;
		private boolean autoSpeed=false;
		private int numTorrents=0;
		private int numLeechingTorrents=0;
		private int numSeedingTorrents=0;
		public int numConnectedSeeds=0;
		public int numConnectedLeechers=0;

		private Float averageUpload=0f;
        private Float averageDownload=0f;
        private Float averageMaxUpload=0f;
        private Float averageMaxDownload=0f;
		private Float averageNumConnectedSeeds=0f;
		private Float averageNumConnectedLeechers=0f;
        
		private Float stdevUpload=0f;
        private Float stdevDownload=0f;
        private Float stdevMaxUpload=0f;
        private Float stdevMaxDownload=0f;
        private Float stdevNumConnectedSeeds=0f;
        private Float stdevNumConnectedLeechers=0f;
		
		public FactMeasurementLpsd() {
			
		}
		
		public FactMeasurementLpsd(DynamicLocalPeerStat lpsd) {

			this.timeRecorded = lpsd.timeRecorded;
			this.uploadRate = lpsd.uploadRate;
			this.downloadRate = lpsd.downloadRate;
			this.maxUploadRate = lpsd.maxUploadRate;
			this.maxDownloadRate = lpsd.maxDownloadRate;
			this.autoSpeed = lpsd.autoSpeed;
			this.numTorrents = lpsd.numTorrents;
			this.numLeechingTorrents = lpsd.numLeechingTorrents;
			this.numSeedingTorrents = lpsd.numSeedingTorrents;
			this.numConnectedSeeds = lpsd.numConnectedSeeds;
			this.numConnectedLeechers = lpsd.numConnectedLeechers;
			
			addEntry(lpsd);

		}
				
		@Override
		public void updateAll(DynamicLocalPeerStat lpsd) {
			
			timeRecorded = (lpsd.timeRecorded);
			uploadRate = (lpsd.uploadRate);
			downloadRate = (lpsd.downloadRate);
			maxUploadRate = (lpsd.maxUploadRate);
			maxDownloadRate = (lpsd.maxDownloadRate);
			autoSpeed = (lpsd.autoSpeed);
			numTorrents = (lpsd.numTorrents);
			numLeechingTorrents = (lpsd.numLeechingTorrents);
			numSeedingTorrents = (lpsd.numSeedingTorrents);
			numConnectedSeeds = (lpsd.numConnectedSeeds);
			numConnectedLeechers = (lpsd.numConnectedLeechers);

			updateDynamic();
			
			if (DEBUG) {

				System.out.println("\nFactMeasurementLpsd");
				for (int i = 0; i < entryList.size(); i++ ) {
					System.out.println(entryList.get(i).timeRecorded + " downloadRate " +
							entryList.get(i).downloadRate + " uploadRate: " +
							entryList.get(i).uploadRate + " maxUploadRate: " +
							entryList.get(i).maxUploadRate + " maxDownloadRate: " +
							entryList.get(i).maxDownloadRate + " numTorrents: " +
							entryList.get(i).numTorrents + " numLeechingTorrents: " +
							entryList.get(i).numLeechingTorrents + " numSeedingTorrents: " +
							entryList.get(i).numSeedingTorrents + " numConnectedSeeds: " +
							entryList.get(i).numConnectedSeeds + " numConnectedLeechers: " +
							entryList.get(i).numConnectedLeechers);
				}
						
				System.out.println("avgDownloadRate: " + averageDownload +
						" avgUploadRate: " + averageUpload);
			
				System.out.println();
			}
			
		}

		public long getTimeRecorded() {
			return timeRecorded;
		}

		public int getUploadRate() {
			return uploadRate;
		}

		public int getDownloadRate() {
			return downloadRate;
		}

		public int getMaxUploadRate() {
			return maxUploadRate;
		}

		public int getMaxDownloadRate() {
			return maxDownloadRate;
		}

		public boolean isAutoSpeed() {
			return autoSpeed;
		}

		public int getNumTorrents() {
			return numTorrents;
		}
		
		public int getNumLeechingTorrents() {
			return numLeechingTorrents;
		}
		
		public int getNumSeedingTorrents() {
			return numSeedingTorrents;
		}
		
		public int getNumConnectedSeeds() {
			return numConnectedSeeds;
		}
		
		public int getNumConnectedLeechers() {
			return numConnectedLeechers;
		}
		
		public Float getAverageUpload() {
			return averageUpload;
		}

		public Float getAverageDownload() {
			return averageDownload;
		}

		public Float getAverageMaxUpload() {
			return averageMaxUpload;
		}

		public Float getAverageMaxDownload() {
			return averageMaxDownload;
		}
		
		public Float getAverageNumConnectedSeeds() {
			return averageNumConnectedSeeds;
		}
		
		public Float getAverageNumConnectedLeechers() {
			return averageNumConnectedLeechers;
		}

		public Float getStdevUpload() {
			return stdevUpload;
		}

		public Float getStdevDownload() {
			return stdevDownload;
		}

		public Float getStdevMaxUpload() {
			return stdevMaxUpload;
		}

		public Float getStdevMaxDownload() {
			return stdevMaxDownload;
		}
		
		public Float getStdevNumConnectedSeeds() {
			return stdevNumConnectedSeeds;
		}

		public Float getStdevNumConnectedLeechers() {
			return stdevNumConnectedLeechers;
		}

		public void setTimeRecorded(long timeRecorded) {
			Long temp = this.timeRecorded;
			this.timeRecorded = timeRecorded;
	        pcs.firePropertyChange("timeRecorded", new Long(temp), new Long(timeRecorded));
		}

		public void setUploadRate(int uploadRate) {
			Integer temp = this.uploadRate;
			this.uploadRate = uploadRate;
	        pcs.firePropertyChange("uploadRate", new Integer(temp), new Integer(uploadRate));

		}

		public void setDownloadRate(int downloadRate) {
			Integer temp = this.downloadRate;
			this.downloadRate = downloadRate;
	        pcs.firePropertyChange("downloadRate", new Integer(temp), new Integer(downloadRate));

		}

		public void setMaxUploadRate(int maxUploadRate) {
			Integer temp = this.maxUploadRate;
			this.maxUploadRate = maxUploadRate;
	        pcs.firePropertyChange("maxUploadRate", new Integer(temp), new Integer(maxUploadRate));

		}

		public void setMaxDownloadRate(int maxDownloadRate) {
			Integer temp = this.maxDownloadRate;
			this.maxDownloadRate = maxDownloadRate;
	        pcs.firePropertyChange("maxDownloadRate", new Integer(temp), new Integer(maxDownloadRate));
		}

		public void setAutoSpeed(boolean autoSpeed) {
			boolean temp = this.autoSpeed;
			this.autoSpeed = autoSpeed;
	        pcs.firePropertyChange("autoSpeed", new Boolean(temp), new Boolean(autoSpeed));
		}

		public void setNumTorrents(int numTorrents) {
			Integer temp = this.numTorrents;
			this.numTorrents = numTorrents;
	        pcs.firePropertyChange("numTorrents", new Integer(temp), new Integer(numTorrents));
		}
		

		public void setNumLeechingTorrents(int numLeechingTorrents) {
			Integer temp = this.numLeechingTorrents;
			this.numLeechingTorrents = numLeechingTorrents;
	        pcs.firePropertyChange("numLeechingTorrents", new Integer(temp), new Integer(numLeechingTorrents));
		}


		public void setNumSeedingTorrents(int numSeedingTorrents) {
			Integer temp = this.numSeedingTorrents;
			this.numSeedingTorrents = numSeedingTorrents;
	        pcs.firePropertyChange("numSeedingTorrents", new Integer(temp), new Integer(numSeedingTorrents));
		}
		
		public void setNumConnectedSeeds(int numConnectedSeeds) {
			Integer temp = this.numConnectedSeeds;
			this.numConnectedSeeds = numConnectedSeeds;
	        pcs.firePropertyChange("numConnectedSeeds", new Integer(temp), new Integer(numConnectedSeeds));
		}
		
		public void setNumConnectedLeechers(int numConnectedLeechers) {
			Integer temp = this.numConnectedLeechers;
			this.numConnectedLeechers = numConnectedLeechers;
	        pcs.firePropertyChange("numConnectedLeechers", new Integer(temp), new Integer(numConnectedLeechers));
		}
		
		public void setAverageUpload(float averageUpload) {
			Float temp = this.averageUpload;
			this.averageUpload = averageUpload;
	        pcs.firePropertyChange("averageUpload", new Float(temp), new Float(averageUpload));
		}

		public void setAverageDownload(float averageDownload) {
			Float temp = this.averageDownload;
			this.averageDownload = averageDownload;
	        pcs.firePropertyChange("averageDownload", new Float(temp), new Float(averageDownload));
		}

		public void setAverageMaxUpload(float averageMaxUpload) {
			Float temp = this.averageMaxUpload;
			this.averageMaxUpload = averageMaxUpload;
	        pcs.firePropertyChange("averageMaxUpload", new Float(temp), new Float(averageMaxUpload));
		}

		public void setAverageMaxDownload(float averageMaxDownload) {
			Float temp = this.averageMaxDownload;
			this.averageMaxDownload = averageMaxDownload;
	        pcs.firePropertyChange("averageMaxDownload", new Float(temp), new Float(averageMaxDownload));
		}

		public void setAverageNumConnectedSeeds(float averageNumConnectedSeeds) {
			Float temp = this.averageNumConnectedSeeds;
			this.averageNumConnectedSeeds = averageNumConnectedSeeds;
	        pcs.firePropertyChange("averageNumConnectedSeeds", new Float(temp), new Float(averageNumConnectedSeeds));
		}

		public void setAverageNumConnectedLeechers(float averageNumConnectedLeechers) {
			Float temp = this.averageNumConnectedLeechers;
			this.averageNumConnectedLeechers = averageNumConnectedLeechers;
	        pcs.firePropertyChange("averageNumConnectedLeechers", new Float(temp), new Float(averageNumConnectedLeechers));
		}

		public void setStdevUpload(float stdevUpload) {
			Float temp = this.stdevUpload;
			this.stdevUpload = stdevUpload;
	        pcs.firePropertyChange("stdevUpload", new Float(temp), new Float(stdevUpload));
		}

		public void setStdevDownload(float stdevDownload) {
			Float temp = this.stdevDownload;
			this.stdevDownload = stdevDownload;
	        pcs.firePropertyChange("stdevDownload", new Float(temp), new Float(stdevDownload));
		}

		public void setStdevMaxUpload(float stdevMaxUpload) {
			Float temp = this.stdevMaxUpload;
			this.stdevMaxUpload = stdevMaxUpload;
	        pcs.firePropertyChange("stdevMaxUpload", new Float(temp), new Float(stdevMaxUpload));
		}

		public void setStdevMaxDownload(float stdevMaxDownload) {
			Float temp = this.stdevMaxDownload;
			this.stdevMaxDownload = stdevMaxDownload;
	        pcs.firePropertyChange("stdevMaxDownload", new Float(temp), new Float(stdevMaxDownload));
		}

		public void setStdevNumConnectedSeeds(float stdevNumConnectedSeeds) {
			Float temp = this.stdevNumConnectedSeeds;
			this.stdevNumConnectedSeeds = stdevNumConnectedSeeds;
	        pcs.firePropertyChange("stdevNumConnectedSeeds", new Float(temp), new Float(stdevNumConnectedSeeds));
		}

		public void setStdevNumConnectedLeechers(float stdevNumConnectedLeechers) {
			Float temp = this.stdevNumConnectedLeechers;
			this.stdevNumConnectedLeechers = stdevNumConnectedLeechers;
	        pcs.firePropertyChange("stdevNumConnectedLeechers", new Float(temp), new Float(stdevNumConnectedLeechers));
		}

		
		public void updateDynamic2() throws SecurityException, NoSuchFieldException, IllegalArgumentException, IllegalAccessException {
			
			HashSet<String> slidingWindowVars = new HashSet<String>();
			HashMap<String, Integer> sumVars = new HashMap<String, Integer>();
			HashMap<String, Float> averageVars = new HashMap<String, Float>();
			HashMap<String, Float> sdqDevVars = new HashMap<String, Float>();
			
			slidingWindowVars.add("uploadRate");
			slidingWindowVars.add("downloadRate");
			slidingWindowVars.add("maxUploadRate");
			slidingWindowVars.add("maxDownloadRate");
			slidingWindowVars.add("numConnectedSeeds");
			slidingWindowVars.add("numConnectedLeechers");
			
        	int size = entryList.size();
        	int startIndex = 0;
        	
        	for (String varName : slidingWindowVars) {
        		sumVars.put(varName, 0);
        		averageVars.put(varName, 0f);
        		sdqDevVars.put(varName, 0f);
        	}
        	
        	for (int i=startIndex; i < size; i++) {
        		
        		DynamicLocalPeerStat lpsd = (DynamicLocalPeerStat) entryList.get(i);
        		
            	for (String varName : slidingWindowVars) {
            		Field field = lpsd.getClass().getField(varName);
            		sumVars.put(varName, sumVars.get(varName) + field.getInt(lpsd));
            	}
        	}
        	
        	for (String varName : slidingWindowVars)
        		averageVars.put(varName, (float) sumVars.get(varName) / (float) size);


        	for (int i=startIndex; i < size; i++) {
        		
        		DynamicLocalPeerStat lpsd = (DynamicLocalPeerStat) entryList.get(i);
        		
            	for (String varName : slidingWindowVars) {
            		Field field = lpsd.getClass().getField(varName);
            		sumVars.put(varName, sumVars.get(varName) + field.getInt(lpsd));
            		sdqDevVars.put(varName, (float) (sdqDevVars.get(varName) 
            				+ Math.pow( (averageVars.get(varName) - field.getInt(lpsd)), 2)));
            	}
        	}
        	
        	this.stdevUpload = ( (float) Math.sqrt(sdqDevVars.get("uploadRate") / size ));
            this.stdevDownload = ( (float) Math.sqrt(sdqDevVars.get("downloadRate") / size) );
            this.stdevMaxUpload = ( (float) Math.sqrt(sdqDevVars.get("maxUploadRate") / size) );
            this.stdevMaxDownload = ( (float) Math.sqrt(sdqDevVars.get("maxDownloadRate") / size) );
            this.stdevNumConnectedSeeds = ( (float) Math.sqrt(sdqDevVars.get("numConnectedSeeds") / size) );
            this.stdevNumConnectedLeechers = ( (float) Math.sqrt(sdqDevVars.get("numConnectedLeechers") / size) );
            
            this.averageUpload = averageVars.get("uploadRate");
            this.averageDownload = averageVars.get("downloadRate");
            this.averageMaxUpload = averageVars.get("maxUploadRate");
            this.averageMaxDownload = averageVars.get("maxDownloadRate");
            this.averageNumConnectedSeeds = averageVars.get("numConnectedSeeds");
            this.averageNumConnectedLeechers = averageVars.get("numConnectedLeechers");
            
		}
		
        public void updateDynamic() {

        	int size = entryList.size();
        	int startIndex = 0;
        	
    		int sumUpload=0;
            int sumDownload=0;
            int sumMaxUpload=0;
            int sumMaxDownload=0;
            int sumNumConnectedSeeds=0;
            int sumNumConnectedLeechers=0;

        	for (int i=startIndex; i < size; i++) {
        		
        		DynamicLocalPeerStat lpsd = (DynamicLocalPeerStat) entryList.get(i);
        		sumUpload += lpsd.uploadRate;
        		sumDownload += lpsd.downloadRate;
        		sumMaxUpload += lpsd.maxUploadRate;
        		sumMaxDownload += lpsd.maxDownloadRate;
        		sumNumConnectedSeeds += lpsd.numConnectedSeeds;
        		sumNumConnectedLeechers += lpsd.numConnectedLeechers;
        	}

        	float averageUpload = ((float) sumUpload / (float) size);
            float averageDownload = ((float) sumDownload / (float) size);
            float averageMaxUpload = ((float) sumMaxUpload / (float) size);
            float averageMaxDownload = ((float) sumMaxDownload / (float) size);
            float averageNumConnectedSeeds = ((float) sumNumConnectedSeeds / (float) size);
            float averageNumConnectedLeechers = ((float) sumNumConnectedLeechers / (float) size);
          
            float sdqDevUpload = 0;
            float sdqDevDownload = 0;
            float sdqDevMaxUpload = 0;
            float sdqDevMaxDownload = 0;
            float sdqDevNumConnectedSeeds = 0;
            float sdqDevNumConnectedLeechers = 0;
        	
        	for (int i=startIndex; i < size; i++) {
        		
        		DynamicLocalPeerStat lpsd = (DynamicLocalPeerStat) entryList.get(i);
        		sdqDevUpload += Math.pow( (averageUpload - lpsd.uploadRate), 2);
        		sdqDevDownload += Math.pow( (averageDownload - lpsd.downloadRate), 2);
        		sdqDevMaxUpload += Math.pow( (averageMaxUpload - lpsd.maxUploadRate), 2);
        		sdqDevMaxDownload += Math.pow( (averageMaxDownload - lpsd.maxDownloadRate), 2);
        		sdqDevNumConnectedSeeds += Math.pow( (averageNumConnectedSeeds - lpsd.numConnectedSeeds), 2);
        		sdqDevNumConnectedLeechers += Math.pow( (averageNumConnectedLeechers - lpsd.numConnectedLeechers), 2);
        	}        	
        	        	
        	this.stdevUpload = ( (float) Math.sqrt(sdqDevUpload / size ));
            this.stdevDownload = ( (float) Math.sqrt(sdqDevDownload / size) );
            this.stdevMaxUpload = ( (float) Math.sqrt(sdqDevMaxUpload / size) );
            this.stdevMaxDownload = ( (float) Math.sqrt(sdqDevMaxDownload / size) );
            this.stdevNumConnectedSeeds = ( (float) Math.sqrt(sdqDevNumConnectedSeeds / size) );
            this.stdevNumConnectedLeechers = ( (float) Math.sqrt(sdqDevNumConnectedLeechers / size) );
            
            this.averageUpload = (averageUpload);
            this.averageDownload = (averageDownload);
            this.averageMaxUpload = (averageMaxUpload);
            this.averageMaxDownload = (averageMaxDownload);
            this.averageNumConnectedSeeds = (averageNumConnectedSeeds);
            this.averageNumConnectedLeechers = (averageNumConnectedLeechers);

        }
        
}
