/**
 * News Project
 *
 * File:         DownloadStats.java
 * RCS:          $Id: StaticPeerStat.java,v 1.1 2010/05/24 19:21:52 mas939 Exp $
 * Description:  DownloadStats class (see below)
 * Author:       David Choffnes
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Apr 10, 2007 at 1:39:15 PM
 * Language:     Java
 * Package:      edu.northwestern.news.stats
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2007, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.stats;

import org.gudy.azureus2.plugins.peers.Peer;

import edu.northwestern.dasu.util.Util;

/**
 * @author Mario Sanchez &lt;msanchez@u.northwestern.edu&gt;
 * Table: remorePeerStatStatic 
 * The PeerStaticData class represents data that needs 
 * to be reported only once during a peer's lifetime.
 */

public class StaticPeerStat {

	final Peer peer;
	int peerId;
	long currentLifetime;
	private int tcpPort;
	private int udpPort;
	private boolean sameCluster = false;
	private long firstSeen;
	private long lastTraceroute = -1;
	private int peerClient;
	private boolean done = false;
	
	public StaticPeerStat(Peer p) {
		peer = p;
		peerClient = -1;
		peerId = -1;
		currentLifetime = p.getStats().getTimeSinceConnectionEstablished();
		firstSeen = Util.currentGMTTime() - currentLifetime;			
		tcpPort = p.getTCPListenPort();
		udpPort = p.getUDPListenPort();
		
	}
		
}
	


